package com.caimei365.manager.controller.caimei.svip;

import com.caimei365.manager.entity.PaginationVo;
import com.caimei365.manager.entity.ResponseJson;
import com.caimei365.manager.entity.caimei.svip.CmSvipHistory;
import com.caimei365.manager.entity.caimei.svip.CmSvipPackage;
import com.caimei365.manager.entity.caimei.svip.CmSvipProduct;
import com.caimei365.manager.service.caimei.svip.CmSvipHistoryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

/**
 * Description
 *
 * @author : Charles
 * @date : 2023/4/7
 */
@RestController
@RequestMapping("/svip/member")
public class CmSvipHistoryApi {

    @Autowired private CmSvipHistoryService historyService;

    /**
     * 超级会员列表
     * @param vip
     * @param pageNum
     * @param pageSize
     * @return
     */
    @GetMapping("/memberList")
    public ResponseJson<PaginationVo<CmSvipHistory>> memberList(CmSvipHistory vip,
                                                 @RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                                 @RequestParam(value = "pageSize",defaultValue = "20")int pageSize) {

        return historyService.memberList(vip, pageNum, pageSize);
    }

    /**
     * 超级会员商品列表
     * @param cmSvipProduct
     * @param pageNum
     * @param pageSize
     * @return
     */
    @GetMapping("/findProductList")
    public ResponseJson<PaginationVo<CmSvipProduct>> findProductList (CmSvipProduct cmSvipProduct,
                                                                      @RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                                                      @RequestParam(value = "pageSize",defaultValue = "20")int pageSize) {

        return historyService.findProductList(cmSvipProduct, pageNum, pageSize);
    }

    /**
     * 套餐配置
     * @return
     */
    @GetMapping("/findPackage")
    public ResponseJson<CmSvipPackage> findPackage() {
        return historyService.findPackage();
    }

    /**
     * 更新超级会员套餐配置
     * @param cmSvipPackage
     * @return
     */
    @PostMapping("/updatePrice")
    public ResponseJson updatePrice(CmSvipPackage cmSvipPackage) {
        return historyService.updatePrice(cmSvipPackage);
    }
}
