package com.caimei365.manager.dao.svip;

import com.caimei365.manager.entity.caimei.svip.CmSku;
import com.caimei365.manager.entity.caimei.svip.CmSvipHistory;
import com.caimei365.manager.entity.caimei.svip.CmSvipPackage;
import com.caimei365.manager.entity.caimei.svip.CmSvipProduct;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * Description
 *
 * @author : Charles
 * @date : 2023/4/7
 */
@Mapper
public interface CmSvipHistoryDao {

    /**
     * 超级会员列表
     * @param vip
     * @return
     */
    List<CmSvipHistory> superFind(CmSvipHistory vip);

    /**
     * 获取状态
     * @param userId
     * @return
     */
    CmSvipHistory findEndTime(Long userId);

    /**
     * 超级会员优惠商品
     * @param svipProduct
     * @return
     */
    List<CmSvipProduct> findProductList(CmSvipProduct svipProduct);

    /**
     * 商品sku数据
     * @param productId
     * @return
     */
    CmSku findSku(Integer productId);

    /**
     * 商品sku
     * @param productId
     * @return
     */
    CmSku findSvipSku(Integer productId);

    /**
     * 套餐配置
     * @return
     */
    List<CmSvipPackage> findPackage();

    /**
     * 更新超级会员套餐信息
     * @param price
     * @param duration
     * @param proportion
     */
    void updatePrice(@Param("price") Double price, @Param("duration") Integer duration, @Param("proportion") Integer proportion);
}
